package countup;

import javax.swing.JPanel;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JButton;

import clock.SetTime;
import clock.TimeClock;


import java.awt.GridBagLayout;
import java.awt.GridBagConstraints;

public class CountupTimer extends JFrame implements SetTime {

	private JPanel jContentPane = null;
	private JLabel timerLabel = null;
	private JButton Start = null;
	private JButton Stop = null;
	private TimeClock clock = null;

	/**
	 * This method initializes Start	
	 * 	
	 * @return javax.swing.JButton	
	 */
	private JButton getStart() {
		if (Start == null) {
			Start = new JButton();
			Start.setText("Start");
			Start.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					clock = new TimeClock(CountupTimer.this);
					clock.start();
				}
			});
		}
		return Start;
	}

	/**
	 * This method initializes Stop	
	 * 	
	 * @return javax.swing.JButton	
	 */
	private JButton getStop() {
		if (Stop == null) {
			Stop = new JButton();
			Stop.setText("Stop");
			Stop.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					if(clock!=null){
						clock.stop();
					}
				}
			});
		}
		return Stop;
	}

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		CountupTimer timer = new CountupTimer();
		timer.show();
	}

	/**
	 * This is the default constructor
	 */
	public CountupTimer() {
		super();
		initialize();
	}

	/**
	 * This method initializes this
	 * 
	 * @return void
	 */
	private void initialize() {
		this.setSize(300, 200);
		this.setContentPane(getJContentPane());
		this.setTitle("JFrame");
	}

	/**
	 * This method initializes jContentPane
	 * 
	 * @return javax.swing.JPanel
	 */
	private JPanel getJContentPane() {
		if (jContentPane == null) {
			GridBagConstraints gridBagConstraints2 = new GridBagConstraints();
			gridBagConstraints2.insets = new java.awt.Insets(15,6,69,52);
			gridBagConstraints2.gridy = 1;
			gridBagConstraints2.ipadx = 32;
			gridBagConstraints2.ipady = -5;
			gridBagConstraints2.gridx = 1;
			GridBagConstraints gridBagConstraints1 = new GridBagConstraints();
			gridBagConstraints1.insets = new java.awt.Insets(14,44,70,6);
			gridBagConstraints1.gridy = 1;
			gridBagConstraints1.ipadx = 30;
			gridBagConstraints1.ipady = -5;
			gridBagConstraints1.gridx = 0;
			GridBagConstraints gridBagConstraints = new GridBagConstraints();
			gridBagConstraints.insets = new java.awt.Insets(13,39,13,48);
			gridBagConstraints.gridx = 0;
			gridBagConstraints.gridy = 0;
			gridBagConstraints.ipadx = 192;
			gridBagConstraints.ipady = 3;
			gridBagConstraints.gridwidth = 2;
			timerLabel = new JLabel();
			timerLabel.setText("0");
			timerLabel.setFont(new java.awt.Font("Dialog", java.awt.Font.BOLD, 24));
			timerLabel.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
			jContentPane = new JPanel();
			jContentPane.setLayout(new GridBagLayout());
			jContentPane.add(timerLabel, gridBagConstraints);
			jContentPane.add(getStart(), gridBagConstraints1);
			jContentPane.add(getStop(), gridBagConstraints2);
		}
		return jContentPane;
	}

	public void setTime(String time) {
		timerLabel.setText(time);		
	}

}
